/*****************************************************/
/* demosq.c                                          */
/* -- Program demonstrates restricting window        */
/*    resizing.                                      */
/*****************************************************/
#include <windows.h>
#include "square.h"

LRESULT CALLBACK __export LwWndProc(HWND hwnd, UINT wm,
  WPARAM wParam, LPARAM lParam);

const char szClass[] = "SquareClass"; // Class name.

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
  LPSTR lpsz, int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    HWND     hwnd;
    MSG      msg;
    WNDCLASS wcs;

    if (NULL == hinsPrev)
        {
        wcs.style = CS_HREDRAW | CS_VREDRAW;
        wcs.lpfnWndProc = LwWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hins;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName = NULL;
        wcs.lpszClassName = szClass;
        if (!RegisterClass(&wcs))
            return FALSE;
        }

    msg.wParam = 0;
    if (NULL != (hwnd = CreateWindow(szClass,
      "Resize me!", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
      CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
      NULL, NULL, hins, NULL)))
        {
        ShowWindow(hwnd, wShow);
        while (GetMessage(&msg, NULL, 0, 0))
            {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            }
        }

    return msg.wParam;
    }

LRESULT CALLBACK __export LwWndProc(HWND hwnd, UINT wm,
  WPARAM wParam, LPARAM lParam)
/*****************************************************/
/* -- Main window procedure.                         */
/*****************************************************/
    {
    /* This is all that's necessary to restrict the */
    /* window to a square. */
    if (FSquareFilter(hwnd, wm, wParam, lParam))
        return 0;

    if (WM_DESTROY == wm)
        PostQuitMessage(0);

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }
