/*
 *  screen.c: Skeletal screen handler for User Interface Generator.
 *      (Relies on code generated by text2c.c for *.x files)
 *  Betsy A. Gamrat
 *  Compile: tcc screen.c keywork.c
 */

#include <stdio.h> 

#include "keywork.h"
#include "pckeys.h"

#define TRUE 1
#define FALSE 0

void display (void)
{
#include "display.x"
}

#include "declare.x"
        
void edit (void)
{
        int key = 0;
        int done = FALSE;
        int field = 0, field_count = 0;

        while (!done)
        {
#include "edit.x"
                switch (key)
                {
                        case RIGHT_ARROW:
                        case TAB:
                        case ENTER:
                                field = (field < field_count) ? field + 1 : 0;
                                break;
                        case SHIFT_TAB:
                        case LEFT_ARROW:
                                field = (field > 0) ? field - 1 : field_count;
                                break;
                        case ESC:
                        case F1:
                        case F2:
                        case F3:
                        case F4:
                        case F5:
                        case F6:
                        case F7:
                        case F8:
                        case F9:
                        case F10:
                        case PAGE_UP:
                        case PAGE_DOWN:
                                done = TRUE;
                                break;
                }
        }
}

void main (void)
{
        display ();
        edit ();
}
